#Lagrange point gui
import Tkinter as tk
import tkFileDialog
import numpy as np
from main import *

bw=12
lw=8
tw=6

class input_field:
	def __init__(self,frame,name,initialvalue,side):
		self.frame=tk.Frame(frame)
		self.label=tk.Label(self.frame,text=name,width=lw,anchor=tk.E)
		self.text=tk.Entry(self.frame,width=tw)
		self.text.insert(0,initialvalue)
		
		self.label.pack(side=tk.LEFT)
		self.text.pack(side=tk.LEFT)
		self.frame.pack(side=side)
		
	def get_float(self):
		return float(self.text.get())

def callback():
	print 'start mainloop'
	m1=M1.get_float()
	m2=M2.get_float()
	r=R.get_float()
	dt=DT.get_float()
	print m1,m2,r
	methods=['lf','bs','rk']
	method=methods[v.get()]
	print method
	#cutoff=cut.get_float()
	main_iteration(m1,m2,r,method,dt*60*60*24)
	
def close():
    close_all()

def quit():
    raise SystemExit
    
import tkMessageBox as mb		
def show_readme():
	f=open("README.txt")
	str=f.read(-1)
	f.close()
	top=tk.Toplevel()
	top.title("README.txt")
	msg = tk.Message(top,text=str)
	msg.pack()


root=tk.Tk() 
root.title('Lagrange point visualization')

parameters1=tk.Frame(root)
parameters2=tk.Frame(root)
buttons=tk.Frame(root)

M1=input_field(parameters1,'Mass 1',1.0,tk.TOP)
M2=input_field(parameters1,'Mass 2',0.01,tk.TOP)
R=input_field(parameters1,'Distance',1.0,tk.TOP)
#cut=input_field(parameters1,'cutoff',-1e-13,tk.TOP)

DT=input_field(parameters2,'dt in days',0.5,tk.TOP)
v=tk.IntVar()
lf=tk.Radiobutton(parameters2,text="Leap-Frog    ",variable=v,value=0).pack(side=tk.TOP)
rk=tk.Radiobutton(parameters2,text="Runge-Kutta",variable=v,value=2).pack(side=tk.TOP)
#bw=12
b1=tk.Button(buttons, text='Run', width=bw, command=callback)
b2=tk.Button(buttons, text='Close Fig', width=bw, command=close)
b3=tk.Button(buttons, text='Quit', width=bw, command=quit)
b4=tk.Button(buttons, text='README', width=bw, command=show_readme)
b1.pack(side=tk.TOP)
b2.pack(side=tk.TOP)
b3.pack(side=tk.TOP)
b4.pack(side=tk.TOP)

IC=tk.Label(root,text='Initial Conditions').grid(row=0,column=0)
time_int=tk.Label(root,text='Time Integration Method').grid(row=0,column=1)
parameters1.grid(row=1,column=0)
parameters2.grid(row=1,column=1,padx=50)
buttons.grid(row=0,rowspan=2,column=2,padx=10)

tk.mainloop()


